/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2c Professional
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : 
Version : 
Date    : 06/10/2010
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8535
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*****************************************************/

#include <mega8535.h>
#include <delay.h>

// Dfinition des entres :
// Entres du comodo
#define Eauto PINC.0         // Switch fonctionement automatique / manuel
#define Ewarn PINC.1         // Warning
#define EclignoD PINC.2      // Clignotant droit
#define EclignoG PINC.3      // Clignotant gauche
#define Ecode PINC.5         // Feux de code
#define Epp PINC.4           // Pleins phares
#define Efrein PINC.6        // Pdale de frein

// Entres analogiques                                          
#define AMavant PINA.0       // Dtection marche avant
#define AMarriere PINA.1     // Dtection marche arrire
#define Aphdiode PINA.2      // Photo diode	
#define Apedale PINA.3       // Potentiomre de la pdale de frein

// Dfinitions des sorties :
// Clignotants 
#define SclignoD PORTD.0      // Clignotants droit
#define SclignoG PORTD.1      // Clignotants gauche

// Feux de codes
#define ScodeAV PORTD.3         // Feux de codes avant
#define ScodeAR PORTD.5     // Feux de codes arrire
#define Svert PORTD.6         // Feux de codes cadre vert

// Pleins Feux
#define Sblanc1 PORTD.4       // Pleins feux avant cadre blanc
#define Sblanc2 PORTD.7       // Pleins feux  avant blancs

// Feux stop et de recul
#define Sstop PORTB.3         // Feux Stop
#define Srecul PORTD.2        // Feux de recul

// Declare your global variables here
int Flag0 = 0;
int Flag1 = 0;  
int Flag2 = 0;

// Interruption 0.5 Hz
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
        if (Flag2 == 1)
        {
        	if (Flag0 == 1) SclignoD = 1;
        	if (Flag1 == 1) SclignoG = 1;
        	Flag2 = 0;
        }
        else
        {
        	SclignoD = 0;
        	SclignoG = 0;
                Flag2 = 1;
        }

}

void main(void)
{
// Declare your local variables here


// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x0D;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x1E;
OCR1AL=0x84;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00; 

// Global enable interrupts
#asm("sei")

//Initialisation des feux
ScodeAV = 0;
ScodeAR = 0;
Svert = 0;
Sblanc1 = 0;
Sblanc2 = 0;
SclignoD = 0;
SclignoG = 0;
Sstop = 0;
Srecul = 0; 


while (1)
{
    if(Eauto == 0)       
    {
    	  if(Ecode == 0) 
          {	
          	ScodeAV = 1;
          	ScodeAR = 1;
          	Svert = 1;
          }
          else 
          {
          	if(Epp == 1)
          	{
                	ScodeAV = 0;
               		ScodeAR = 0;
          		Svert = 0;
          	}
          }
          if(Epp == 0)
	  {	
	  	ScodeAV = 1;
	   	ScodeAR = 1;
	    	Svert = 1;
	     	Sblanc1 = 1;
	      	Sblanc2 = 1;
	  }
	  else
	  {
          	if(Ecode == 1)
          	{
                	ScodeAV = 0;
	   		ScodeAR = 0;
	    		Svert = 0;
	     		Sblanc1 = 0;
	      		Sblanc2 = 0;
          	}
          }
	  if(Ewarn == 0)
	  {
	  	Flag0 = 1;
	  	Flag1 = 1;
	  }
	  else
	  {
	  	if (EclignoD == 0) Flag0 =1;
	  	else 
	  	{
	  		Flag0 = 0;
	  		SclignoD = 0; 
	  	}
	  	if (EclignoG == 0) Flag1 = 1; 
	  	else 
	  	{
	  		Flag1 = 0;
	  		SclignoG = 0;
	  	}
	  }
    }  	  
    else
};
}
